; ####################################################
;       William F. Cravener updated 7/28/2003

;       mixer COMPONENTTYPE added by www.dougiem.fsnet.co.uk/asm 30Sept05

; ####################################################
    
        ;.486
        ;.model flat,stdcall
        ;option casemap:none;

        ;include \masm32\include\windows.inc
        ;include \masm32\include\kernel32.inc
        ;include \masm32\include\winmm.inc

        ;includelib \masm32\lib\kernel32.lib
        ;includelib \masm32\lib\winmm.lib

; ####################################################

       GetMixerVolume       proto :dword
       CloseMixerVolume     proto
       SetMixerVolume       proto :dword


.const
MIXER_ERROR      equ 0FFFFFFFFh 

DST_FIRST        equ 0
DST_UNDEFINED    equ 0
DST_DIGITAL      equ 1
DST_LINE         equ 2 
DST_MONITOR      equ 3 
DST_HEADPHONES   equ 5
DST_TELEPHONE    equ 6
DST_WAVEIN       equ 7
DST_VOICEIN      equ 8
DST_LAST         equ 8

DST_SPEAKERS     equ 4         ; master volume
SRC_FIRST        equ 1000h
SRC_UNDEFINED    equ 1000h + 0 
SRC_DIGITAL      equ 1000h + 1 ; spdif vol
SRC_LINE         equ 1000h + 2 ; linein2 vol
SRC_MICROPHONE   equ 1000h + 3
SRC_SYNTHESIZER  equ 1000h + 4 ; midi vol
SRC_COMPACTDISC  equ 1000h + 5
SRC_TELEPHONE    equ 1000h + 6
SRC_PCSPEAKER    equ 1000h + 7
SRC_WAVEOUT      equ 1000h + 8 ; wav vol
SRC_AUXILIARY    equ 1000h + 9
SRC_ANALOG       equ 1000h + 10 ;aux2 vol
SRC_LAST         equ 1000h + 10


_NOERROR         equ 0
_ERROR           equ 1
_BADDEVICEID     equ 2
_NOTENABLED      equ 3
_ALLOCATED       equ 4
_INVALHANDLE     equ 5
_NODRIVER        equ 6
_NOMEM           equ 7
_NOTSUPPORTED    equ 8
_BADERRNUM       equ 9
_INVALFLAG       equ 10
_INVALPARAM      equ 11
_HANDLEBUSY      equ 12
_INVALIDALIAS    equ 13
_LASTERROR       equ 13


.data
        MixerHandle    dd 0
        VolCtlIDMtr    dd 0

        mxc            MIXERCONTROL <?>
        mxcd           MIXERCONTROLDETAILS <?>
        mxcdVol        MIXERCONTROLDETAILS_UNSIGNED <?>
        mxlc           MIXERLINECONTROLS <?>
        mxl            MIXERLINE <?>

; ####################################################

.code

;DllEntry proc hInstance:HINSTANCE, reason:DWORD, reserved1:DWORD
;  mov  eax,TRUE
;  ret
;DllEntry Endp


; ###############################################################


GetMixerVolume proc cType:dword

        invoke mixerOpen,ADDR MixerHandle,0,0,0,0
     .if eax == MMSYSERR_NOERROR 

       mov mxl.cbStruct,sizeof MIXERLINE
       mov eax,cType
       mov mxl.dwComponentType,eax
       invoke mixerGetLineInfo,MixerHandle,addr mxl,MIXER_GETLINEINFOF_COMPONENTTYPE
       mov eax,mxl.dwLineID

            mov mxlc.dwLineID,eax
            mov mxlc.cbStruct,SIZEOF mxlc
            mov mxlc.dwControlType,MIXERCONTROL_CONTROLTYPE_VOLUME
            mov mxlc.cControls,1
            mov mxlc.cbmxctrl,SIZEOF mxc
            mov mxlc.pamxctrl,OFFSET mxc
            invoke mixerGetLineControls,MixerHandle,ADDR mxlc,MIXER_GETLINECONTROLSF_ONEBYTYPE
            mov eax,mxc.dwControlID
            mov VolCtlIDMtr,eax
            mov mxcdVol.dwValue,1
            mov mxcd.cbStruct,SIZEOF mxcd
            mov eax,VolCtlIDMtr  
            mov mxcd.dwControlID,eax
            mov mxcd.cChannels,1
            mov mxcd.cMultipleItems,0
            mov mxcd.cbDetails,SIZEOF mxcdVol
            mov mxcd.paDetails,OFFSET mxcdVol
            invoke mixerGetControlDetails,MixerHandle,ADDR mxcd,MIXER_GETCONTROLDETAILSF_VALUE
            mov eax,mxcdVol[0].dwValue
     .else
            mov eax,MIXER_ERROR
     .endif
        ret

GetMixerVolume endp
    
; ###############################################################

SetMixerVolume proc VolValue:DWORD

        mov eax,VolValue
        mov mxcdVol[0].dwValue,eax
        mov mxcd.cbStruct,SIZEOF mxcd
        mov eax,VolCtlIDMtr
        mov mxcd.dwControlID,eax
        mov mxcd.cChannels,1
        mov mxcd.cMultipleItems,0
        mov mxcd.cbDetails,SIZEOF mxcdVol
        mov mxcd.paDetails,OFFSET mxcdVol
        invoke mixerSetControlDetails,MixerHandle,ADDR mxcd,MIXER_GETCONTROLDETAILSF_VALUE
        .if eax == MMSYSERR_NOERROR
            mov eax,0
        .else
            mov eax,MIXER_ERROR
        .endif            
        ret

SetMixerVolume endp

; ###############################################################

CloseMixerVolume proc

        invoke mixerClose,ADDR MixerHandle
        ret

CloseMixerVolume endp

; ###############################################################

;End DllEntry
